float4x4 matWorld;
float4x4 matWorldViewProj;
float4 vecViewPos;

struct VS_OUT
{
	float4 Pos : POSITION;
	float4 WorldPos : TEXCOORD0;
};

VS_OUT Shader_VS(float4 inPos : POSITION)
{
	VS_OUT Out = (VS_OUT)0;
	
	Out.WorldPos = mul(inPos, matWorld);
	Out.Pos = mul(inPos, matWorldViewProj);
	
	return Out;
}

float4 Shader_PS(float4 inPos : TEXCOORD0) : COLOR
{
	float4 Color = distance(inPos.xyz, vecViewPos.xyz);
	return Color;
}

technique tech_00
{
	pass pass_00
	{
		VertexShader = compile vs_2_0 Shader_VS();
		PixelShader = compile ps_2_0 Shader_PS();
	}
}
