float4x4 matWorld;
float4x4 matWorldViewProj;
float4 vecViewPos;

texture entSkin1;
texture b_reflection_bmap;
texture b_refraction_bmap;

sampler2D smpNormal = sampler_state
{
	Texture = <entSkin1>;
	
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	
	AddressU		= Wrap;
	AddressV		= Wrap;
};

sampler2D smpRefl = sampler_state
{
	Texture = <b_reflection_bmap>;
	
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	
	AddressU		= Clamp;
	AddressV		= Clamp;
};

sampler2D smpRefr = sampler_state
{
	Texture = <b_refraction_bmap>;
	
	MinFilter	= linear;
	MagFilter	= linear;
	MipFilter	= linear;
	
	AddressU		= Clamp;
	AddressV		= Clamp;
};

struct VS_OUT
{
	float4 Pos : POSITION;
	float2 Tex : TEXCOORD0;
};

VS_OUT Shader_VS(float4 inPos : POSITION, float2 inTex : TEXCOORD0)
{
	VS_OUT Out = (VS_OUT)0;
	
	Out.Pos = mul(inPos, matWorldViewProj);
	
	Out.Tex = inTex;
	
	return Out;
}

float4 Shader_PS(float2 inTex : TEXCOORD0) : COLOR
{
	float4 Color = tex2D(smpNormal, inTex);
	Color.a = 1.0;
	
	return Color;
}

technique tech_00
{
	pass pass_00
	{
		CullMode = None;
		
		VertexShader = compile vs_2_0 Shader_VS();
		PixelShader = compile ps_2_0 Shader_PS();
	}
}
