#include <acknex.h>
#include <default.c>

#include "PP_Helper.c"

BMAP* camera_clean;
BMAP* b_reflection;
BMAP* b_refraction;

MATERIAL* matBlackout =
{
	effect = "Blackout.fx";
}

MATERIAL* matBloomAdd =
{
	effect = "BloomAdd.fx";
}

MATERIAL* matBlurH =
{
	effect = "Blur.fx";
}

MATERIAL* matBlurV =
{
	effect = "Blur.fx";
}

MATERIAL* matRadialBlur =
{
	effect = "RadialBlur.fx";
}

MATERIAL* matDepth =
{
	effect = "Depth.fx";
}

MATERIAL* matDoF =
{
	effect = "DoF.fx";
}

MATERIAL* matMultiTex =
{
	effect = "MultiTex.fx";
}

MATERIAL* matModelLight =
{
	effect = "ModelLight.fx";
}

MATERIAL* matWater =
{
	effect = "Water.fx";
}

MATERIAL* matReed =
{
	effect =
	"
		technique t0
		{
			pass p0
			{
				CullMode = None;
				AlphaTestEnable = True;
				ZWriteEnable = True;
			}
		}
	";
}

void main()
{
	level_load("");
	you = ent_create("schilf.mdl", vector(300, 0, 0), NULL);
	you.material = matReed;
	vec_scale(you.scale_x, 0.2);
	
	you = ent_create("water_n.hmp", vector(0, 0, -5), NULL);
	you.material = matWater;
	vec_scale(you.scale_x, 100);
	
	camera_clean = bmap_createblack(screen_size.x, screen_size.y, 24);
	camera.bmap = camera_clean;
	
	PP_Add(matBlackout, camera, NULL);
	PP_Add(matBlurH, camera, NULL);
	PP_Add(matBlurV, camera, NULL);
	PP_Add(matBloomAdd, camera, NULL);
	
	matBlurH.skill1 = floatv(1);
	matBlurH.skill2 = floatv(0);
	
	matBlurV.skill1 = floatv(0);
	matBlurV.skill2 = floatv(1);
	
	//Reflection
	VIEW* v_reflection = view_create(-1);
	set(v_reflection, VISIBLE);
	
	b_reflection = bmap_createblack(screen_size.x, screen_size.y, 24);
	v_reflection.bmap = b_reflection;
	
	//Refraction
	VIEW* v_refraction = view_create(-1);
	set(v_refraction, VISIBLE);
	
	b_refraction = bmap_createblack(screen_size.x, screen_size.y, 24);
	v_refraction.bmap = b_refraction;
	
	while(1)
	{
		//Reflection
		vec_set(v_reflection.x, camera.x);
		v_reflection.z = 2*(-5)-camera.z;
		
		v_reflection.pan = camera.pan;
		v_reflection.tilt = -camera.tilt;
		v_reflection.roll = -camera.roll;
		
		v_reflection.size_x = camera.size_x;
		v_reflection.size_y = camera.size_y;
		
		v_reflection.aspect = -camera.aspect;
		v_reflection.clip_far = camera.clip_far;
		
		//Refraction
		vec_set(v_refraction.x, camera.x);
		vec_set(v_refraction.pan, camera.pan);
		
		v_refraction.size_x = camera.size_x;
		v_refraction.size_y = camera.size_y;
		
		v_refraction.aspect = camera.aspect;
		v_refraction.clip_far = camera.clip_far;
		
		wait(1);
	}
}